#! /usr/bin/perl
use warnings;
use strict;

use Test::More 'no_plan';

BEGIN { # override now in order to hijack it later 
    *CORE::GLOBAL::gmtime = sub (;$) { CORE::gmtime( @_ ? $_[0] : time ) };
}

{
    my $time = time;
    my @bare_gmt = gmtime;
    my @arg_gmt  = gmtime( $time );
    is_deeply \@bare_gmt, \@arg_gmt, "gmtime($time)";
}
{
    my $fix = 1204286400; # 29 Feb 2008 12:00:00 GMT
    no warnings 'redefine';
    local *CORE::GLOBAL::gmtime = sub (;$) {
        CORE::gmtime( @_ ? $_[0] : $fix );
    };
    my $time = $fix;
    my @bare_gmt = gmtime;
    my @arg_gmt  = gmtime( $time );
    is_deeply \@bare_gmt, \@arg_gmt, "gmtime($time)";
}
