#! /usr/local/bin/perl5100
use warnings;
use strict;

BEGIN {
    *CORE::GLOBAL::open = sub (*;$@) {
        my( $handle, $mode, $file, @list ) = @_;

        # make sure bareword filehandles are in their own package
        my $pkg = caller;
        if ( defined $handle and !ref $handle ) { # bareword handle
            no strict 'refs';
            $handle = *{ "$pkg\:\:$handle" };
        } elsif ( !defined $handle ) {            # lexical undefined
            $_[0] = $handle = do {
                no strict 'refs';
                \*{ sprintf "%s::NH%d%d%d", $pkg, $$, time, rand 100 };
            };
        }
    
        # convert to two argumented open()
        defined $file and $mode .= " $file";
        CORE::open( $handle, $mode );
    };
}

#print ReadFile::read_bareword( "< $0" );
print ReadFile::read_handle( "< $0" );

exit;
{
    no warnings 'redefine';
    local *CORE::GLOBAL::open = sub (*;$@) {
        my( $handle, $mode, $file, @list ) = @_;

        # make sure bareword filehandles are in their own package
        my $pkg = caller;
        if ( defined $handle and !ref $handle ) { # bareword handle
            no strict 'refs';
            $handle = *{ "$pkg\:\:$handle" };
        } elsif ( !defined $handle ) {            # lexical undefined
            $_[0] = $handle = do {
                no strict 'refs';
                \*{ sprintf "%s::NH%d%d%d", $pkg, $$, time, rand 100 };
            };
        }

        # convert to two argumented open()
        defined $file and $mode .= " $file";
        print "open($handle, '$mode')\n";

        if ( $mode =~ m/^(?:<\s*)?($0)/ ) {
            tie $handle, 'ReadSelf', $1;
	} elsif ( $mode =~ m/\|$/ ) {
            tie $handle, 'ReadSelf', "pipe: $mode";
        } else {
            CORE::open( $handle, $mode );
        }
    };

    print ReadFile::read_bareword( "< $0" );
    print ReadFile::read_bareword( "system_profiler -detailLevel mini |" );
}

package ReadSelf;

sub TIEHANDLE {
    my( $class, $info ) = @_;
    my $store = "Should have read '$info'\n\tthis is to test slurp.\n";
    bless \$store, $class;
}

sub READLINE {
    my $self = shift;
    defined $$self or return;
    length $$self or $$self = undef, return;
 
    if ( wantarray ) {
        my @lines = map +"$_\n" => split m/\n/, $$self;
        $$self = undef;
        return @lines;
    } else {
        local $/ = defined $/ ? $/ : '\z';
        my $line  = $$self =~ s@^(.*?$/)@@s ? $1 : undef;
        return $line;
    }
}

sub CLOSE {
    my $self = shift;
    untie $self;
}

1;

package ReadFile;

sub read_bareword {
    my( $file ) = @_;

    local *FH;
    open FH, $file or die "Cannot open($file): $!";

    my $lines = do { local $/; <FH> };

    close FH;

    return $lines;
}

sub read_handle {
    my( $file ) = @_;

    open my $fh, $file or die "Cannot open($file): $!";

    my $lines = do { local $/; <$fh> };

    close $fh;

    return $lines;
}

1;
