package MyOpen;
use warnings;
use strict;

our $VERSION = 0.01;

sub core_open (*;$@) {
    my( $handle, $mode, $file, @list ) = @_;

    # make sure filehandles are in their own package
    my $pkg = caller;
    if ( defined $handle and !ref $handle ) { # bareword handle
        no strict 'refs';
        $handle = *{ "$pkg\:\:$handle" };
    } elsif ( !defined $handle ) { # undefined scalar, provide GLOBref
        $_[0] = $handle = do {
            no strict 'refs';
            \*{ sprintf "%s::NH%d%d%d", $pkg, $$, time, rand 100 };
        };
    }

    # convert to two argumented open()
    defined $file and $mode .= " $file";
    CORE::open( $handle, $mode );
};

# prepare open() for runtime override
BEGIN { *CORE::GLOBAL::open = \&core_open }

1;
