#! perl
use warnings;
use strict;

use Test::More 'no_plan';

BEGIN { use_ok 'MyOpen' }
ok defined &CORE::GLOBAL::open, "CORE::GLOBAL::open() defined";

my $content;
{
    CORE::open( my $fh, '<', $0 ) or die "Cannot CORE::open($0): $!";
    isa_ok $fh, 'GLOB';
    $content = do { local $/; <$fh> };
    close $fh;
    like $content, qr/BEGIN { use_ok 'MyOpen' }/, "contains MyOpen";
}
{
    open my $fh, '<', $0 or die "Cannot open($0): $!";
    isa_ok $fh, 'GLOB';
    my $file = do { local $/; <$fh> };
    close $fh;

    is $file, $content, "contents still the same";
}
