package Coords;
use warnings;
use strict;

use overload
    q{""}    => \&as_string,
    fallback => 1;

sub new {
    my( $class, $x, $y ) = @_;
    bless { _x => $x || 0, _y => $y || 0 }, $class;
}

sub move {
    my( $self, $dx, $dy ) = @_;
    ref $dx eq __PACKAGE__ and ( $dx, $dy ) = ( $dx->{_x}, $dx->{_y} );
    $self->{_x} += $dx;
    $self->{_y} += $dy;
    return $self;
}

sub as_string {
    my( $self ) = @_;
    return sprintf "(%d, %d)", $self->{_x}, $self->{_y};
}

1;
