package Coords;
use warnings;
use strict;

use overload
    q{""}    => \&as_string,
    q{+}     => \&add_move,
    fallback => 1;

sub new {
    my( $class, $x, $y ) = @_;
    bless { _x => $x || 0, _y => $y || 0 }, $class;
}

sub copy {  return bless { _x => $_[0]->{_x}, _y => $_[0]->{_y} }, ref $_[0]; }

sub move {
    my( $self, $dx, $dy ) = @_;
    ref $dx and ( $dx, $dy ) = ( $dx->{_x}, $dx->{_y} );

    $self->{_x} += $dx;
    $self->{_y} += $dy;
    return $self;
}

sub add_move {
    my( $a1, $a2 ) = @_;
    ref $a1 and ref $a2 or die "Cannot move() with constants!";
    $a1->copy->move( $a2 );
}

sub as_string {
    my( $self ) = @_;
    return sprintf "(%d, %d)", $self->{_x}, $self->{_y};
}

1;
