#! perl
use warnings;
use strict;

use Test::More 'no_plan';

use_ok 'Coords';

my $c1 = Coords->new( 150, 150 );
is $c1, $c1->as_string, "overloaded stringify: $c1";

my $c2 = Coords->new( -50, 50 );
is $c2, $c2->as_string, "overloaded stringify: $c2";

my $r1 = $c1->copy;
isa_ok $r1, 'Coords';
is $r1, $c1, "->copy: $r1";

$r1->move( $c2 );
is $r1, "(100, 200)", "->move$c2: $r1";

my $r2 = $c1 + $c2;
isa_ok $r2, 'Coords';
is $r2, "(100, 200)", "overloaded addition: $r2";
