#! perl
use warnings;
use strict;

use Test::More 'no_plan';

use Coords ':constants';
ok defined $INC{ 'Coords.pm' }, "use_ok Coords";

{
    my $c1 = "(150, 150)";
    isa_ok $c1, 'Coords';
    is $c1, "(150, 150)", "Constant converted to Coords '$c1'";

    my $r1 = $c1;
    isa_ok $r1, 'Coords';
    is $r1, "(150, 150)", "Copy worked: '$r1'";
}
{
    my $c1 = "(150, 150)";
    isa_ok $c1, 'Coords';
    is $c1, "(150, 150)", "Constant converted to Coords '$c1'";

    my $r1 = $c1 + "(50, -50)";
    isa_ok $r1, 'Coords';
    is $r1, "(200, 100)", "moved with constant '$r1'";
}
{
    my $c1 = "(50, -50)";
    isa_ok $c1, 'Coords';
    is $c1, "(50, -50)", "Constant converted to Coords '$c1'";

    no Coords ':constants';
    my $c2 = Coords->new( "$c1" );
    isa_ok $c2, 'Coords';
    is $c2, "(50, -50)", "new() from constant '$c2'";
    my $r1 = "(150, 150)" + $c2;
    isa_ok $r1, 'Coords';
    is $r1, "(200, 100)", "moved from constant '$r1'";
}
{
    my $c1 = "(50, -50)";
    isa_ok $c1, 'Coords';
    is $c1, "(50, -50)", "Constant converted to Coords '$c1'";

    my $r1 = '(150, 150)' + $c1;
    isa_ok $r1, 'Coords';
    is $r1, "(200, 100)", "moved from constant '$r1'";
}
