#! perl
use warnings;
use strict;

use Test::More tests => 3;

use_ok 'Hugeint';

my $hi = Hugeint->new( 255 );
isa_ok $hi, 'Hugeint';
my $out;
{

    local *FH;
    tie *FH, 'CatchOut';
    my $stdout = select \*FH;

    $hi->Dump;

    select $stdout;
    $out = ${ tied *FH };

    untie *FH;
}

is $out, <<EODUMP, "Capture ->Dump() output";
Internal size: 2
 Decimal size: 3
    as_string: 255
    as_binary: 00000000 11111111
EODUMP

package CatchOut;

sub TIEHANDLE {
    my $class = shift;
    bless \(my $store), $class;
}

sub PRINT {
    my $self = shift;
    my $comma = $, || "";
    $$self .= join $comma, @_;
}

1;
