package CharArray;
use warnings;
use strict;

our $VERSION = 0.01;

sub TIEARRAY {
    my $class = shift;
    ref $_[0] or die "Usage: tie CharArray => \$scalar;";
    bless $_[0], $class;
}

sub UNTIE { }

sub FETCHSIZE {
    my $self = shift;
    defined $self ? length( $$self ) : 0;
}

sub FETCH {
    my( $self, $index ) = @_;
    $index > length $$self and $$self .= "" x ( 1 + $index - length $$self );
    defined $$self
        ? substr $$self, $index, 1
        : undef;
}

sub STORE {
    my( $self, $index, $value ) = @_;
    $index > length $$self and $$self .= "" x ( 1 + $index - length $$self );
    substr $$self, $index, 1, $value;
}

sub PUSH {
    my $self = shift;
    $$self .= join "", @_;
    length $$self;
}

sub POP {
    my $self = shift;
    my $last = substr $$self, -1, 1;
    $$self = substr $$self, 0, length( $$self ) - 1;
    $last;
}

1;
