#! /usr/bin/perl
use warnings;
use strict;

use Test::More 'no_plan';

use_ok 'CharArray';

{
    my $orig = 'value';
    tie my @ca, 'CharArray', \$orig;
    is $ca[0], 'v', "First value '@ca' (${ tied( @ca ) })";
    push @ca, 's';
    is @ca, 6, "new length (${ tied( @ca ) })";

    my $sorted = join "", sort @ca;
    is $sorted, 'aelsuv', "sorting the array works ($sorted)";

    untie @ca;
    is $orig, 'values', "still the changed value in original ($orig)";
}

