#! perl
use warnings;
use strict;
use Data::Dumper; $Data::Dumper::Indent = 1;
# $Id$

use Test::More 'no_plan';

use_ok 'FeedIn';

{
    local *IN;
    tie *IN, 'FeedIn', "regel 1\nregel 2";
    my $line = <IN>;
    is $line, "regel 1\n", "Read a line '$line'";

    $line = <IN>;
    is $line, "regel 2", "Read a line '$line'";
}

{
    local *IN;
    tie *IN, 'FeedIn', "regel 1\nregel 2";
    my @line = <IN>;
    is scalar @line, 2, "2 lines in list-context"
        or diag Dumper \@line;

    is $line[0], "regel 1\n", "Read a line '$line[0]'";
    is $line[1], "regel 2", "Read a line '$line[1]'";
}

{
    local *IN;
    tie *IN, 'FeedIn', "regel 1\nregel 2";
    my @line;
    while ( <IN> ) { push @line, $_ }
    is scalar @line, 2, "2 lines in list-context"
        or diag Dumper \@line;

    is $line[0], "regel 1\n", "Read a line '$line[0]'";
    is $line[1], "regel 2", "Read a line '$line[1]'";
}

{
    local *IN;
    tie *IN, 'FeedIn', "regel 1\nregel 2";
    my $lines = do { local $/; <IN> };
    is $lines, "regel 1\nregel 2", "Slurp-mode";
}
